> For the complete documentation index, see [llms.txt](https://developers-apps-in-toss.toss.im/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers-apps-in-toss.toss.im/documentation/api-and-sdk-en/sdk/domains-api/device/device.getalbumitems.md).

# Device.getAlbumItems

> Functional API `fetchAlbumItems`You can use the same feature with it as well.

### Feature description

Select photos and videos from the user's album and fetch them. If selection is canceled, an empty array `[]`is returned, and `types`if you don't specify it, only photos are selected.

Toss app Android/iOS `5.261.0` You can use it on version and above. Before calling, `Device.getAlbumItems.isSupported()`you can check whether it is supported. If you call it on an unsupported version, `UNSUPPORTED_APP_VERSION` an error occurs.

### Type

```ts
Device.getAlbumItems(options?: FetchAlbumItemsOptions): Promise<AlbumItemResponse[]>;
```

**Params**

```ts
type AlbumItemType = "PHOTO" | "VIDEO";

type FetchAlbumItemsOptions = {
  /** The list of media types to retrieve. If not specified, only photos are retrieved. */
  types?: AlbumItemType[];
  /** The maximum number of items to retrieve. The default is 10. */
  maxCount?: number;
  /** The maximum width of the image (px). The default is 1024. */
  maxWidth?: number;
  /** Whether to return the image dataUri as Base64. The default is false. */
  base64?: boolean;
};
```

**Response**

```ts
type AlbumItemResponse = {
  id: string;
  dataUri: string;
  type: "PHOTO" | "VIDEO";
};
```

### Error

The error code is the `error.code` value.

| Code                      | Description                                                                                                                                                                                                                                    |
| ------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `NOT_ALLOWED`             | Album access is not allowed.                                                                                                                                                                                                                   |
| `INVALID_REQUEST`         | The request parameters are invalid.                                                                                                                                                                                                            |
| `INVALID_DATA`            | The media data is invalid.                                                                                                                                                                                                                     |
| `UNSUPPORTED_APP_VERSION` | If the running version of the Toss app doesn't support this feature, it occurs immediately upon call. `Device.getAlbumItems.isSupported()`Check in advance with `error.message`and, if it occurs, show the user the (update guidance message). |

### Example code

```js
import { Device } from "@apps-in-toss/web-framework";

async function pickAlbumItems() {
  if (!Device.getAlbumItems.isSupported()) {
    console.warn("It can't be used with the current Toss app version.");
    return;
  }

  try {
    const items = await Device.getAlbumItems({
      types: ["PHOTO", "VIDEO"],
      maxCount: 5,
      base64: true,
    });

    if (items.length === 0) {
      console.log("The selection was canceled.");
      return;
    }
    console.log(items);
  } catch (error) {
    console.error(error);
  }
}

document.getElementById("pick-media").addEventListener("click", pickAlbumItems);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developers-apps-in-toss.toss.im/documentation/api-and-sdk-en/sdk/domains-api/device/device.getalbumitems.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
